#!/bin/bash
#------------------------------------------------------------------------------
#
# /etc/apcupsd/make-hiddev.sh   Create hiddev device-nodes for
#                               your usb-subsystem.
#
# last edited:             21.04.2005
#
# Copyright (c) 2005       Gunther Schmidt
#	                   1012-621@online.de
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------

CREATE_DIR () {
    echo "...creating directory /dev/usb/hid..."
    mkdir -p /dev/usb/hid
}

CREATE_NODES () {
    echo "...creating device nodes..."
    m=0
    n=96

    while [ ${m} -le 15 ]; do
        mknod /dev/usb/hid/hiddev${m} c 180 ${n}
        echo "...hiddev${m}..."
        let m+=1
        let n+=1
    done
    echo "...done."
}

if [ -d /dev/usb/hid ]; then
    echo "...found /dev/usb/hid - skippin' creation..."
    test -e /dev/usb/hid/hiddev0 || CREATE_NODES
else
    CREATE_DIR
    CREATE_NODES
fi
