#! /bin/sh
#
#------------------------------------------------------------------------------
# /tmp/preinstall.sh :	   setting up APCUPSD Power Management on EISFAIR
#
# last edited:             21.04.2005
#
# Copyright (c) 2005       Gunther Schmidt
#	                   1012-621@online.de
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------
	
CONFFILE='/etc/config.d/apcups'
RETURN='pass'

CHECK_STATE ()
{
if [ $RETURN ]; then
	colecho "done!" gn
else
	RETURN='pass'
	colecho "failed!" br x brbl
fi
}

clrhome  

if [ -e ${CONFFILE} ]; then
	colecho "Found a previous installed version of APC UPS..." gn
	echo -n "...creating BACKUP of config-file... "
	cp -f ${CONFFILE} /tmp/apcups.pre || RETURN=''
	CHECK_STATE
	
	if [ -f /var/install/packages/apcups-cgi ]; then
               echo;colecho "Found a previous installed version of APC UPS-CGI ..." gn
	       echo -n "...creating BACKUP of config-files... "
	       cp -f /etc/apcupsd/hosts.conf /tmp/hosts.pre || RETURN=''
	       cp -f /etc/apcupsd/multimon.conf /tmp/multimon.pre || RETURN=''
	       CHECK_STATE
	       echo "...executing the deinstall-script for APC UPS-CGI..."
	       echo
	       /var/install/bin/anykey
	       /var/install/deinstall/apcups-cgi
	       if [ -e /var/install/deinstall/apcups-cgi ]; then
	       	       rm -f /var/install/deinstall/apcups-cgi
               fi
               if [ -e /var/install/packages/apcups-cgi ]; then
	               rm -f /var/install/packages/apcups-cgi
               fi
	fi
	
	echo "...executing the deinstall-script for APC UPS..."
	
	echo
	/var/install/bin/anykey
	/var/install/deinstall/apcups

	
	. /tmp/apcups.pre
	if [ $NISPORT -ne '3551' ]; then
             colecho ">>> Starting with v3.10.6 the standard NISPORT is 3551! <<<" gn
             NISPORT='3551'
	fi
	
	if [ ! $SLAVE_N ]; then
             SLAVE_N='0'
        fi
        
        if [ ! $MONITOR_N ]; then
             MONITOR_N='1'
             MONITOR_1_IP='127.0.0.1'
             MONITOR_1_DESCRIPTION='Local Host'
        fi
        
 	if [ ! $FIELD_N ]; then
             TEMP_MM='Celsius'
             FIELD_N='9'
             FIELD_1_VARIABLE='SYSTEM'
             FIELD_1_NAME='System'
             FIELD_1_SUFFIX=''
             FIELD_2_VARIABLE='MODEL'
             FIELD_2_NAME='Model'
             FIELD_2_SUFFIX=''
             FIELD_3_VARIABLE='STATUS'
             FIELD_3_NAME='Status'
             FIELD_3_SUFFIX=''
             FIELD_4_VARIABLE='battpct'
             FIELD_4_NAME='Battery Chg'
             FIELD_4_SUFFIX='%'
             FIELD_5_VARIABLE='utility'
             FIELD_5_NAME='Utility'
             FIELD_5_SUFFIX='VAC'
             FIELD_6_VARIABLE='loadpct'
             FIELD_6_NAME='UPS Load'
             FIELD_6_SUFFIX='%'
             FIELD_7_VARIABLE='UPSTEMP'
             FIELD_7_NAME='UPS Temp'
             FIELD_7_SUFFIX=''
             FIELD_8_VARIABLE='runtime'
             FIELD_8_NAME='Batt. Run Time'
             FIELD_8_SUFFIX='min.'
             FIELD_9_VARIABLE='DATA'
             FIELD_9_NAME='Data'
             FIELD_9_SUFFIX='All data'
        fi
        
        if [ ! $CHANGEME ]; then
            CHANGEME='yes'
            CHANGEME_MSG='UPS battery needs changing NOW.'
        fi

        if [ ! $COMMFAILURE ]; then
            COMMFAILURE='yes'
            COMMFAILURE_MSG='Serial port communications with UPS lost.'
        fi

        if [ ! $COMMOK ]; then
            COMMOK='yes'
            COMMOK_MSG='Serial port communications with UPS restored.'
        fi

        if [ ! $MAINSBACK ]; then
            MAINSBACK='yes'
            MAINSBACK_MSG='Power has returned.'
        fi

        if [ ! $MASTERCONNECT ]; then
            MASTERCONNECT='yes'
            MASTERCONNECT_MSG='Slave received connection from master.'
        fi

        if [ ! $MASTERTIMEOUT ]; then
            MASTERTIMEOUT='yes'
            MASTERTIMEOUT_MSG='Slave lost contact with master.'
        fi

        if [ ! $ONBATTERY ]; then
            ONBATTERY='yes'
            ONBATTERY_MSG='Power Failure !!!'
        fi
        
	echo
else 
	UPSCABLE='940-0024C'
	UPSTYPE='smartups'
	DEVICE='/dev/ttyS0'
	LOCKFILE='/var/lock'
	BATTERYLEVEL='5'
	MINUTES='3'
	TIMEOUT='0'
	NETSERVER='on'
	NISPORT='3551'
	EVENTSFILE='/etc/apcupsd/apcupsd.events'
	STATTIME='0'
	STATFILE='/etc/apcupsd/apcupsd.status'
	LOGSTATS='off'
	DATATIME='0'
	UPSCLASS='standalone'
	UPSMODE='disable'
	NETACCESS='false'
        SLAVE_N='0'
        MONITOR_N='1'
        MONITOR_1_IP='127.0.0.1'
        MONITOR_1_DESCRIPTION='Local Host'
        TEMP_MM='Celsius'
        FIELD_N='9'
        FIELD_1_VARIABLE='SYSTEM'
        FIELD_1_NAME='System'
        FIELD_1_SUFFIX=''
        FIELD_2_VARIABLE='MODEL'
        FIELD_2_NAME='Model'
        FIELD_2_SUFFIX=''
        FIELD_3_VARIABLE='STATUS'
        FIELD_3_NAME='Status'
        FIELD_3_SUFFIX=''
        FIELD_4_VARIABLE='battpct'
        FIELD_4_NAME='Battery Chg'
        FIELD_4_SUFFIX='%'
        FIELD_5_VARIABLE='utility'
        FIELD_5_NAME='Utility'
        FIELD_5_SUFFIX='VAC'
        FIELD_6_VARIABLE='loadpct'
        FIELD_6_NAME='UPS Load'
        FIELD_6_SUFFIX='%'
        FIELD_7_VARIABLE='UPSTEMP'
        FIELD_7_NAME='UPS Temp'
        FIELD_7_SUFFIX=''
        FIELD_8_VARIABLE='runtime'
        FIELD_8_NAME='Batt. Run Time'
        FIELD_8_SUFFIX='min.'
        FIELD_9_VARIABLE='DATA'
        FIELD_9_NAME='Data'
        FIELD_9_SUFFIX='All data'
        CHANGEME='yes'
        COMMFAILURE='yes'
        COMMOK='yes'
        MAINSBACK='yes'
        MASTERCONNECT='yes'
        MASTERTIMEOUT='yes'
        ONBATTERY='yes'
        CHANGEME_MSG='UPS battery needs changing NOW.'
        COMMFAILURE_MSG='Serial port communications with UPS lost.'
        COMMOK_MSG='Serial port communications with UPS restored.'
        MAINSBACK_MSG='Power has returned.'
        MASTERCONNECT_MSG='Slave received connection from master.'
        MASTERTIMEOUT_MSG='Slave lost contact with master.'
        ONBATTERY_MSG='Power Failure !!!'
fi

colecho "Installing APC UPS Powermanagement for Eisfair..." gn
echo -n "...generating EISFAIR config-file... "
(echo "#------------------------------------------------------------------------------"
 echo "# /etc/config.d/apcups	- configuration file for APC UPS"
 echo "#			  Power Management on EISFAIR"
 echo "#"
 echo "#			- for apcupsd release 3.10.17"
 echo "#"
 echo "# Author:		Gunther Schmidt"
 echo "#			1012-621@online.de" 
 echo "#"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# >>> General configuration parameters <<<"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# UPSCABLE simple | smart | 940-00(20B,23A,24B,24C,24G,95A,95B,95C) |"
 echo "#		940-15(24C) | ether | usb ]"
 echo "#	defines the type of cable that you have."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "UPSCABLE='"$UPSCABLE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# UPSTYPE	[ backups | sharebasic | netups | backupspro |"
 echo "#		smartvsups |newbackupspro | backupspropnp |"
 echo "#		smartups | matrixups | sharesmart | usb ]"
 echo "#	defines the type of UPS you have."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "UPSTYPE='"$UPSTYPE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# DEVICE </dev/'serial port'>; ttyS0 and ttyS1 supported."
 echo "#        <usb> for USB-type."
 echo "#        name of your port."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "DEVICE='"$DEVICE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# LOCKFILE	<path to lockfile>;"
 echo "#	path for serial port lock file"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "LOCKFILE='"$LOCKFILE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# >>> configuration parameters used during power failures <<<"
 echo "# "
 echo "# Note: BATTERYLEVEL, MINUTES, and TIMEOUT work in conjunction, so"
 echo "# the first that occurs will cause the initation of a shutdown."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# BATTERYLEVEL	<int>"
 echo "# 	If during a power failure, the remaining battery percentage"
 echo "#	(as reported by the UPS) is below or equal to BATTERYLEVEL," 
 echo "#	apcupsd will initiate a system shutdown."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "BATTERYLEVEL='"$BATTERYLEVEL"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# MINUTES	<time in minutes>"
 echo "#	If during a power failure, the remaining runtime in minutes" 
 echo "#	(as calculated internally by the UPS) is below or equal to MINUTES,"
 echo "#	apcupsd, will initiate a system shutdown."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "MINUTES='"$MINUTES"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# TIMEOUT	<time in seconds>"
 echo "#	If during a power failure, the UPS has run on batteries for TIMEOUT"
 echo "#	many seconds or longer, apcupsd will initiate a system shutdown."
 echo "#	A value of 0 disables this timer."
 echo "#"
 echo "#  Note, if you have a Smart UPS, you will most likely want to disable"
 echo "#    this timer by setting it to zero. That way, you UPS will continue"
 echo "#    on batteries until either the % charge remaing drops to or below BATTERYLEVEL,"
 echo "#    or the remaining battery runtime drops to or below MINUTES.  Of course,"
 echo "#    if you are testing, setting this to 60 causes a quick system shutdown"
 echo "#    if you pull the power plug."   
 echo "#  If you have an older dumb UPS, you will want to set this to less than"
 echo "#    the time you know you can run on batteries."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "TIMEOUT='"$TIMEOUT"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# ANNOY		<time in seconds>"
 echo "#	Time in seconds between annoying users to signoff prior to"
 echo "#	system shutdown. 0 disables."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "ANNOY='"$ANNOY"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# ANNOYDELAY	<time in seconds>"
 echo "#	Initial delay after power failure before warning users to get"
 echo "#	off the system."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "ANNOYDELAY='"$ANNOYDELAY"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# NOLOGON	[ disable | timeout | percent | minutes | always ]"
 echo "#	The condition which determines when users are prevented from"
 echo "#	logging in during a power failure."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "NOLOGON='"$NOLOGON"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# KILLDELAY <seconds>  0 disables"
 echo "#	If killdelay is set, apcupsd will continue running after a"
 echo "#	shutdown has been requested, and after the specifiec time in"
 echo "#	seconds attempt to kill the power.  This is for use on systems"
 echo "#	where apcupsd cannot regain control after a shutdown."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "KILLDELAY='"$KILLDELAY"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# >>> Configuration statements for the network information server <<<"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# NETSERVER	[ on | off ]"
 echo "#	If netstatus is on, a network information server process"
 echo "#	will be started for serving the STATUS and EVENT data over"
 echo "#	the network (used by CGI programs)."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "NETSERVER='"$NETSERVER"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# NISPORT	<port> default is 3551"
 echo "#	port to use for sending STATUS and EVENTS data over the network."
 echo "#	It is not used unless NETSERVER is on. If you change this port,"
 echo "#	you will need to change the corresponding value in the cgi directory"
 echo "#	and rebuild the cgi programs."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "NISPORT='"$NISPORT"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# EVENTSFILE	<string>"
 echo "#	If you want the last few EVENTS to be available over the network"
 echo "#	by the network information server, you must define a EVENTSFILE."
 echo "#	Only the last 50 or so events are kept."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "EVENTSFILE='"$EVENTSFILE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# >>> Configuration statements to control apcupsd system logging <<<"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# STATTIME	<time in seconds>"
 echo "#	Time interval in seconds between writing the STATUS file; 0 disables"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "STATTIME='"$STATTIME"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# STATFILE	<path>"
 echo "#	Location of STATUS file (written to only if STATTIME is non-zero)"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "STATFILE='"$STATFILE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# LOGSTATS	[ on | off ]"
 echo "#"
 echo "# Note!	This generates a lot of output, so if you turn this on," 
 echo "#	be sure that the file defined in syslog.conf for LOG_NOTICE"
 echo "#	is a named pipe. You probably do not want this on."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "LOGSTATS='"$LOGSTATS"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# DATATIME	<time in seconds>"
 echo "#	Time interval in seconds between writing the DATA records to"
 echo "#	the log file. 0 disables."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "DATATIME='"$DATATIME"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# FACILITY defines the logging facility (class) for logging to syslog."
 echo "#          If not specified, it defaults to "daemon". This is usefull" 
 echo "#          if you want to separate the data logged by apcupsd from other"
 echo "#          programs."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "FACILITY='"$FACILITY"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# >>> Configuration statements used while updating the UPS EPROM <<<"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# UPSNAME	<UPS_IDEN>; max 8 characters NO BLANKS!"
 echo "#	used only during -n or --rename-ups"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "UPSNAME='"$UPSNAME"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# BATTDATE	<mm/dd/yy>"
 echo "#	used only during -u or --update-battery-date"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "BATTDATE='"$BATTDATE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# SENSITIVITY	[H | M | L); default = H"
 echo "#	 Sensitivity to line voltage quality."
 echo "#	(H cause faster transfer to batteries)"
 echo "#	set during -c or --configure"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "SENSITIVITY='"$SENSITIVITY"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# WAKEUP	[000 | 060 | 180 | 300]; default = 000"
 echo "#	UPS delay after power return (seconds)"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "WAKEUP='"$WAKEUP"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# SLEEP		[020 | 180 | 300 | 600]; default = 020"
 echo "# 	UPS Grace period after request to power off (seconds)"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "SLEEP='"$SLEEP"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# LOTRANSFER	<int>"
 echo "#	Low line voltage causing transfer to batteries"
 echo "#	The permitted values depend on your model as defined by last letter" 
 echo "# 	of FIRMWARE or APCMODEL. Some representative values are:"
 echo "#	D 106 103 100 097"
 echo "#	M 177 172 168 162"
 echo "#	A 092 090 088 086"
 echo "#	I 208 204 200 196     (default = 0 => not valid)"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "LOTRANSFER='"$LOTRANSFER"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# HITRANSFER	<int>"
 echo "#	High line voltage causing transfer to batteries"
 echo "#	The permitted values depend on your model as defined by last letter" 
 echo "#	of FIRMWARE or APCMODEL. Some representative values are:"
 echo "#	D 127 130 133 136"
 echo "#	M 229 234 239 244"
 echo "#	A 108 110 112 114"
 echo "#	I 253 257 261 265     (default = 0 => not valid)"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "HITRANSFER='"$HITRANSFER"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# RETURNCHARGE	[00 | 15 | 50 | 90]; default = 15"
 echo "#	Battery change needed to restore power"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "RETURNCHARGE='"$RETURNCHARGE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# BEEPSTATE	[0 | T | L | N]; default = 0"
 echo "#	Alarm delay 0 = zero delay after pwr fail,"
 echo "#	T = power fail + 30 sec, L = low battery, N = never"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "BEEPSTATE='"$BEEPSTATE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# LOWBATT	[02 | 05 | 07 | 10]; default = 02"
 echo "#	Low battery warning delay in minutes"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "LOWBATT='"$LOWBATT"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# OUTPUTVOLTS	<int>"
 echo "#	UPS Output voltage when running on batteries"
 echo "#	The permitted values depend on your model as defined by last letter" 
 echo "#	of FIRMWARE or APCMODEL. Some representative values are:"
 echo "#	D 115"
 echo "#	M 208"
 echo "#	A 100"
 echo "#	I 230 240 220 225     (default = 0 => not valid)"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "OUTPUTVOLTS='"$OUTPUTVOLTS"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# SELFTEST	[336 | 168 | ON | OFF]; default = 336"
 echo "#	Self test interval in hours 336=2 weeks, 168=1 week, ON=at power on"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "SELFTEST='"$SELFTEST"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# >>> Configuration statements used if sharing"
 echo "#     a UPS and controlling it via the network <<<"   
 echo "#"
 echo "#      The configuration statements below are used if you"
 echo "#      want to share one UPS to power multiple machines and have them"
 echo "#      communicate by the network. Obviously, the master is connected"
 echo "#      to the UPS via the serial cable, and it communicates to the"
 echo "#      "slaves" via the network -- i.e. the slaves get their info"
 echo "#      concerning the UPS via the ethernet."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# UPSCLASS	[standalone | shareslave | sharemaster | netslave | netmaster]"
 echo "#	normally standalone unless you share a UPS with multiple machines."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "UPSCLASS='"$UPSCLASS"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# UPSMODE	[ disable | share | net | sharenet ]"
 echo "#	Unless you want to share the UPS (power multiple machines)."
 echo "#	this should be disable"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "UPSMODE='"$UPSMODE"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "#NETACCESS	[ true | false ]"
 echo "#	Enable Network Access Support"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "NETACCESS='"$NETACCESS"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# NETTIME <time in seconds>"
 echo "#	The interval in seconds that the master uses to send" 
 echo "#	informatins to slave machines. This rate is automatically"
 echo "#	set to 1 second if the UPS goes on batteries and reset to"
 echo "#	your specified value when the mains power returns. A  typical"
 echo "#	value might be 60 seconds"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "NETTIME='"$NETTIME"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# NETPORT <port adress>"
 echo "#	This port number is used for communication in the master/slave"
 echo "#	networking code."
 echo "#------------------------------------------------------------------------------"
 echo " " 
 echo "NETPORT='"$NETPORT"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# MASTER <name of the master> for SLAVE machines"
 echo "#	Used in SLAVE configuration files, this is the network name"
 echo "#	of the master which is authorised to send commands to this slave."
 echo "#	When specifying a MASTER directive, you will also have to specify"
 echo "#	UPSCABLE='ether'. To avoid problems resolving the machine name"
 echo "#	if DNS is not running, you can use IP adresses on the MASTER"
 echo "#	and SLAVE directives."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "MASTER='"$MASTER"'"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# SLAVE_N <number of slave(s)> used only in MASTER configuration"
 echo "#	This specifies then number of slaves attached to this master."
 echo "#	There can be a maximum of 20 slaves attached to one master."
 echo "#"
 echo "# SLAVE_x <name of the slave> x is to be replaced by a valid number."
 echo "#	This is the name of a slave machine that depends on this master."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "SLAVE_N='"$SLAVE_N"'"
 echo "SLAVE_1='"$SLAVE_1"'"
 echo "SLAVE_2='"$SLAVE_2"'") >> $CONFFILE
if [ ${SLAVE_N} -gt "2" ]; then
	while [ ${n:=2} != ${SLAVE_N} ]; do
		let n+=1
		eval WORD='$SLAVE_'$n
		echo "SLAVE_"$n"='$WORD'" >> $CONFFILE
	done
fi 
(echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# USERMAGIC <user defined magic> used only in SLAVE configuration"
 echo "#	The USERMAGIC directive is a sort of password that gives a second"
 echo "#	level of identification security in a slave configuration file."
 echo "# 	It may be up to 17 characters in length and should be unique for"
 echo "#	each slave."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "USERMAGIC='"$USERMAGIC"'"
) >> $CONFFILE || RETURN=''

(echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# >>> Configuration statements for the CGI-package <<<"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# MONITOR (Network UPS Tools - hosts.conf)"
 echo "#"
 echo "#        This file does double duty - it lists the systems that multimon will"
 echo "#        monitor, and also specifies the systems that upsstats is allowed to"
 echo "#        watch.  It keeps people from feeding random addresses to upsstats,"
 echo "#        among other things.  upsimage also uses this file to know who it"
 echo "#        may speak to. upsfstats too."
 echo "#"
 echo "#        Usage: list systems running apcupsd that you want to monitor"
 echo "#"
 echo "#        Example:"
 echo "#        MONITOR_N='3'"
 echo "#        MONITOR_1_IP='127.0.0.1'"
 echo "#        MONITOR_1_DESCRIPTION='Local Host'"
 echo "#        MONITOR_2_IP='10.64.1.1'"
 echo "#        MONITOR_2_DESCRIPTION='Sierra High School data room #1'"
 echo "#        MONITOR_3_IP='10.78.1.1'"
 echo "#        MONITOR_3_DESCRIPTION='Finance department'"
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "MONITOR_N='$MONITOR_N'"
) >> $CONFFILE
n=1
while [ $n -le $MONITOR_N ]; do
	eval WORD='$MONITOR_'$n'_IP'
	echo "MONITOR_"$n"_IP='$WORD'" >> $CONFFILE || RETURN=''

	eval WORD='$MONITOR_'$n'_DESCRIPTION'
	echo "MONITOR_"$n"_DESCRIPTION='$WORD'" >> $CONFFILE || RETURN=''
	let n+=1
done

(echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# TEMP_MM (Network UPS Tools - multimon.conf)"
 echo "#"
 echo "#         Temperature selection. Pick 'Celsius' or 'Fahrenheit'."
 echo "#         This will override the --enable-celsius setting from the"
 echo "#         compile.  UPSTEMP (below) will use this setting by default."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "TEMP_MM='"$TEMP_MM"'"
 ) >> $CONFFILE || RETURN=''
 
(echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# FIELD (Network UPS Tools - multimon.conf)"
 echo "#"
 echo "#         Format: <variable> '<field name>' '<field suffix>'"
 echo "#"
 echo "# <variable> is either a word from the UPS protocol like battchg"
 echo "#         or a special word in uppercase."
 echo "#"
 echo "# Special words are:"
 echo "#         MODEL    - Show the model name for this system in cyan"
 echo "#"
 echo "#         STATUS   - Parse the status for this system using the"
 echo "#                    appropriate color."
 echo "#"
 echo "#         UPSTEMP and AMBTEMP use the default scale.  This is set"
 echo "#         to C if you use e-enable-celsius at compile time *or* if"
 echo "#         you use 'TEMPC' above. All suffixes will be ignored."
 echo "#"
 echo "#         UPSTEMP  - Show the UPS temperature in the default scale."
 echo "#         UPSTEMPC - Show the UPS temperature in degrees C."
 echo "#         UPSTEMPF - Show the UPS temperature in degrees F."
 echo "#"
 echo "#         These are only useful if you have a Smart-UPS model with "
 echo "#         the Measure-UPS II measurement card.  No other models"
 echo "#         presently support these features."
 echo "#"
 echo "#         AMBTEMP  - Show the ambient temperature in the default scale."
 echo "#         AMBTEMPC - Show the ambient temperature in degrees C."
 echo "#         AMBTEMPF - Show the ambient temperature in degrees F."
 echo "#"
 echo "# They're called "special" since they actually understand the content"
 echo "# being printed and do other things based on what's in there."
 echo "#"
 echo "# <field name> is what you'd like this column to be called on the page."
 echo "#          Remember that this is HTML, so you can actually embed markup"
 echo "#          in here. This means you can even include images here."
 echo "#          You can include quotes (and backslashes!) in the string by"
 echo "#          escaping them with a backslash."
 echo "#"
 echo "# <field suffix> is typically something like % or VAC.  It's useful if"
 echo "#          you want to convey the units that apply to a value."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "FIELD_N='"$FIELD_N"'"
) >> $CONFFILE || RETURN=''
n=1
while [ $n -le $FIELD_N ]; do
	eval WORD='$FIELD_'$n'_VARIABLE'
	echo "FIELD_"$n"_VARIABLE='$WORD'" >> $CONFFILE || RETURN=''

	eval WORD='$FIELD_'$n'_NAME'
	echo "FIELD_"$n"_NAME='$WORD'" >> $CONFFILE || RETURN=''
	
	eval WORD='$FIELD_'$n'_SUFFIX'
	echo "FIELD_"$n"_SUFFIX='$WORD'" >> $CONFFILE || RETURN=''
	let n+=1
done

(echo " "
 echo "#------------------------------------------------------------------------------"
 echo "# Mail-events <yes/no>' Mail-package must be installed for this option to work."
 echo "#"
 echo "#          Here you can specify if you want to be notifyed"
 echo "#          via email on the following events:"
 echo "#"
 echo "#          CHANGEME       ...when apcupsd detects that the battery should"
 echo "#                            be replaced."
 echo "#          COMMFAILURE    ...when apcupsd loses contact with the UPS"
 echo "#                            (i.e. the serial connection is not responding)."
 echo "#          COMMOK         ...when apcupsd restores contact with the "
 echo "#                            UPS (i.e. the serial connection is restored)."
 echo "#          MAINSBACK      ...when the UPS goes back on to the mains"
 echo "#                            after a power failure."
 echo "#          MASTERCONNECT  ...when the master connects to the slave."
 echo "#"
 echo "#          MASTERTIMEOUT  ...when the master does not contact the slave for"
 echo "#                            two minutes."
 echo "#          ONBATTERY      ...when the UPS goes on batteries."
 echo "#"
 echo "#          You may define an idividual message for each event"
 echo "#          in the *_MSG field."
 echo "#------------------------------------------------------------------------------"
 echo " "
 echo "CHANGEME='"$CHANGEME"'"
 echo "CHANGEME_MSG='"$CHANGEME_MSG"'"
 echo
 echo "COMMFAILURE='"$COMMFAILURE"'"
 echo "COMMFAILURE_MSG='"$COMMFAILURE_MSG"'"
 echo
 echo "COMMOK='"$COMMOK"'"
 echo "COMMOK_MSG='"$COMMOK_MSG"'"
 echo
 echo "MAINSBACK='"$MAINSBACK"'"
 echo "MAINSBACK_MSG='"$MAINSBACK_MSG"'"
 echo
 echo "MASTERCONNECT='"$MASTERCONNECT"'"
 echo "MASTERCONNECT_MSG='"$MASTERCONNECT_MSG"'"
 echo
 echo "MASTERTIMEOUT='"$MASTERTIMEOUT"'"
 echo "MASTERTIMEOUT_MSG='"$MASTERTIMEOUT_MSG"'"
 echo
 echo "ONBATTERY='"$ONBATTERY"'"
 echo "ONBATTERY_MSG='"$ONBATTERY_MSG"'"
) >> $CONFFILE || RETURN=''
CHECK_STATE

if [ -e /tmp/apcups.pre ]; then
	echo;colecho ">>> Make sure to verify this settings since <<<" gn
	colecho ">>>    some variables may have changed !    <<<" gn
	echo;echo -n "...removing BACKUP-file... "
	rm -f /tmp/apcups.pre || RETURN=''
	CHECK_STATE
fi

if [ -e /tmp/hosts.pre ]; then
	echo;colecho ">>> You will find your old hosts.conf <<<" gn
             colecho ">>> and multimon.conf as *.pre files  <<<" gn
             colecho ">>>       in /etc/apcupsd/.           <<<" gn
	echo;echo -n "...copying BACKUP-files... "
        if [ -e /etc/apcupsd ]; then
           echo "/etc/apcupsd/ is existing..."
        else
           mkdir /etc/apcupsd
        fi
	cp -f /tmp/hosts.pre /etc/apcupsd/hosts.pre || RETURN=''
	cp -f /tmp/multimon.pre /etc/apcupsd/multimon.pre || RETURN=''
	rm -f /tmp/*.pre || RETURN=''
	CHECK_STATE
fi

sleep 5
